package com.xindazhou.user.api.oauth2;

import com.xindazhou.framework.common.biz.system.oauth2.OAuth2TokenCommonApi;
import com.xindazhou.framework.common.pojo.CommonResult;
import com.xindazhou.framework.common.util.object.BeanUtils;
import com.xindazhou.framework.tenant.core.aop.TenantIgnore;
import com.xindazhou.framework.common.biz.system.oauth2.dto.OAuth2AccessTokenCheckRespDTO;
import com.xindazhou.framework.common.biz.system.oauth2.dto.OAuth2AccessTokenCreateReqDTO;
import com.xindazhou.framework.common.biz.system.oauth2.dto.OAuth2AccessTokenRespDTO;
import com.xindazhou.user.dal.dataobject.oauth2.OAuth2AccessTokenDO;
import com.xindazhou.user.service.oauth2.OAuth2TokenService;
import jakarta.annotation.Resource;
import org.springframework.context.annotation.Primary;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import static com.xindazhou.framework.common.pojo.CommonResult.success;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@Validated
@Primary // 用户服务禁用 OAuth2TokenCommonApi 的 Feign 客户端，只使用本地实现
public class OAuth2TokenApiImpl implements OAuth2TokenCommonApi {

    @Resource
    private OAuth2TokenService oauth2TokenService;

    @Override
    @TenantIgnore // Token 创建时无需租户编号
    public CommonResult<OAuth2AccessTokenRespDTO> createAccessToken(OAuth2AccessTokenCreateReqDTO reqDTO) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.createAccessToken(
                reqDTO.getUserId(), reqDTO.getUserType(), reqDTO.getClientId(), reqDTO.getScopes());
        return success(BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenRespDTO.class));
    }

    @Override
    @TenantIgnore // 访问令牌校验时，无需传递租户编号；主要解决上传文件的场景，前端不会传递 tenant-id
    public CommonResult<OAuth2AccessTokenCheckRespDTO> checkAccessToken(String accessToken) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.checkAccessToken(accessToken);
        return success(BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenCheckRespDTO.class));
    }

    @Override
    @TenantIgnore // Token 删除时无需租户编号
    public CommonResult<OAuth2AccessTokenRespDTO> removeAccessToken(String accessToken) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.removeAccessToken(accessToken);
        return success(BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenRespDTO.class));
    }

    @Override
    @TenantIgnore // Token 刷新时无需租户编号
    public CommonResult<OAuth2AccessTokenRespDTO> refreshAccessToken(String refreshToken, String clientId) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.refreshAccessToken(refreshToken, clientId);
        return success(BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenRespDTO.class));
    }

    @Override
    @TenantIgnore // Token 撤销检查时无需租户编号
    public CommonResult<Boolean> isTokenRevoked(String accessToken) {
        boolean revoked = oauth2TokenService.isTokenRevoked(accessToken);
        return success(revoked);
    }

}

